inputFolder = getDirectory("EDM SBM Analysis - Choose the input folder!");
images = getFileList(inputFolder);

function isImage(filename) {
	extensions = newArray("tif", "tiff", "jpg", "bmp");
	result = false;
	for (i=0; i<extensions.length; i++) {
		if (endsWith(toLowerCase(filename), "." + extensions[i]))
		result = true;
		}
	return result;
}


run("Set Measurements...", "  perimeter shape feret's display redirect=None decimal=3");
setBatchMode(true);
reportFile1 = File.open(inputFolder +"EDM-SBS.txt");

for (i=0; i<images.length; i++) {
	inputPath = inputFolder + images[i];
	if (isImage(inputPath)) {
		open(inputPath);
		showProgress(i, images.length);
		run("8-bit");
		setAutoThreshold("Default");
		//run("Threshold...");
		setThreshold(0, 128);
		run("Convert to Mask");
		run("Set Scale...", "distance=1 known=1 pixel=1 unit=unit global");
		run("Clear Results");		
		run("Analyze Particles...", "size=0-Infinity circularity=0.00-1.00 show=Nothing display exclude summarize");	
		TotalArea=0;	
		line="F\t"+images[i] + "\t" + nResults;
		print(reportFile1,line);
		print(reportFile1,"\n");
		for (row=0;row<nResults;row++) {
			TotalArea=TotalArea+getResult("Area", row);
			line=""+getResult("Area", row)+"\t"+getResult("Feret", row);
			print(reportFile1,line);
			print(reportFile1,"\n");
		}

		run("Distance Map");
		getStatistics(area, mean, min, max);
		line="E\t" + images[i] + "\t" +  max; 
		print(reportFile1,line);
		print(reportFile1,"\n");
		line="0\t" + TotalArea; 
		print(reportFile1,line);print(reportFile1,"\n");

		curtit=getTitle();
		for (j=1;j<max;j++){
			run("Duplicate...", "title="+curtit); 
			//setAutoThreshold("Default");
			setThreshold(j, 255);
			run("Convert to Mask");
			run("Invert");
			run("Distance Map");
			setThreshold(j, 255);
			run("Convert to Mask");
			run("Invert");	
			run("Clear Results");		
			run("Analyze Particles...", "size=0-Infinity circularity=0.00-1.00 show=Nothing display exclude");
			TotalArea=0;
			for (row=0;row<nResults;row++) {
 				TotalArea=TotalArea+getResult("Area", row);
				}

			line=""+j + "\t" + TotalArea; 
			print(reportFile1,line);print(reportFile1,"\n");
			close();
			}
		close();
		}
}
File.close(reportFile1);
setBatchMode(false);
exit();

